package io.useless.login

import java.util.UUID

import io.useless.auth.{ App, User }

/**
 * Login is an App-specific view of a User that is authenticated via password.
 *
 * If handle and / or name is specified, they should take precedence over the
 * underlying User handle / name.
 */
trait Login {

  def user: User

  def handle: Option[String]

  def name: Option[String]

}

object Login {

  class BaseLogin(
    val user: User,
    val handle: Option[String],
    val name: Option[String]
  ) extends Login

  def apply(user: User, handle: Option[String], name: Option[String]): Login = {
    new BaseLogin(user, handle, name)
  }

}
