package io.useless.play.json

import java.util.UUID
import play.api.libs.json._
import play.api.libs.functional.syntax._

import io.useless.auth.{ AccessToken, Account }
import io.useless.play.json.UuidJson._
import AccountJson._
import RoleJson._

object AccessTokenJson {

  implicit val accessTokenReads = (
    (__ \ "guid").read[UUID] ~
    (__ \ "resource_owner").read[Account] ~
    (__ \ "client").read[Option[Account]]
  ) {(guid: UUID, resourceOwner: Account, client: Option[Account]) =>
    AccessToken(guid, resourceOwner, client)
  }

  implicit val accessTokenWrites = new Writes[AccessToken] {
    def writes(accessToken: AccessToken): JsValue ={
      Json.obj(
        "guid" -> accessToken.guid,
        "resource_owner" -> accessToken.resourceOwner,
        "client" -> accessToken.client
      )
    }
  }

}
