package io.useless.play.json

import java.util.UUID
import play.api.libs.json._
import play.api.libs.functional.syntax._

import io.useless.auth.Api
import io.useless.auth.Role._
import io.useless.play.json.UuidJson._
import RoleJson._

object ApiJson {

  implicit val apiReads: Reads[Api] = (
    (__ \ "guid").read[UUID] ~
    (__ \ "roles").read[Seq[Role]] ~
    (__ \ "api" \ "name").read[String] ~
    (__ \ "api" \ "url").read[String]
  ) { (guid: UUID, roles: Seq[Role], name: String, url: String) =>
    new Api(guid, roles, name, url)
  }

  implicit val apiWrites = new Writes[Api] {
    def writes(api: Api): JsValue = {
      Json.obj(
        "guid" -> api.guid,
        "roles" -> api.roles,
        "api" -> Json.obj(
          "name" -> api.name,
          "url" -> api.url
        )
      )
    }
  }

}
