package io.useless.play.json

import java.util.UUID
import play.api.libs.json._
import play.api.libs.functional.syntax._

import io.useless.auth.App
import io.useless.auth.Role._
import io.useless.play.json.UuidJson._
import RoleJson._

object AppJson {

  implicit val appReads: Reads[App] = (
    (__ \ "guid").read[UUID] ~
    (__ \ "roles").read[Seq[Role]] ~
    (__ \ "app" \ "name").read[String]
  ) { (guid: UUID, roles: Seq[Role], name: String) =>
    new App(guid, roles, name)
  }

  implicit val appWrites = new Writes[App] {
    def writes(app: App): JsValue = {
      Json.obj(
        "guid" -> app.guid,
        "roles" -> app.roles,
        "app" -> Json.obj(
          "name" -> app.name
        )
      )
    }
  }

}
