package io.useless.play.json

import play.api.libs.json._
import play.api.libs.functional.syntax._

import io.useless.login.Login
import io.useless.auth.User

object LoginJson {

  import UserJson._

  implicit val loginReads: Reads[Login] = (
    (__ \ "user").read[User] ~
    (__ \ "handle").read[Option[String]] ~
    (__ \ "name").read[Option[String]]
  ) { (user: User, handle: Option[String], name: Option[String]) =>
    Login(user, handle, name)
  }

  implicit val loginWrites = new Writes[Login] {
    def writes(login: Login): JsValue = {
      Json.obj(
        "user" -> login.user,
        "handle" -> login.handle,
        "name" -> login.name
      )
    }
  }

}
