package io.useless.play.json

import play.api.libs.json._
import play.api.data.validation.ValidationError

import io.useless.auth.Role
import Role._

object RoleJson {

  implicit object RoleJsonFormat extends Format[Role] {

    def reads(role: JsValue): JsResult[Role] = role match {
      case JsString(s) => try { JsSuccess(Role.withName(s)) } catch {
        case e: NoSuchElementException =>
          JsError(Seq(JsPath() -> Seq(ValidationError("validate.error.expected.role.enum"))))
      }
      case _ => JsError(Seq(JsPath() -> Seq(ValidationError("validate.error.expected.role"))))
    }

    def writes(role: Role): JsValue = JsString(role.toString)

  }

}
